<html>
  <head>
    <title><?php echo __('Related pages'); ?></title>
    <?php echo dcPage::jsToolMan();?>
    <?php echo dcPage::jsPageTabs($default_tab);?>
    <?php echo dcPage::jsLoad('js/jquery/jquery-ui.custom.js');?>
    <?php echo dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js');?>
    <?php echo dcPage::jsLoad('index.php?pf=related/js/_pages.js');?>
    <script type="text/javascript">
      //<![CDATA[
      <?php echo dcPage::jsVar('dotclear.msg.confirm_delete_posts',__("Are you sure you want to delete selected pages?"));?>
      //]]>
    </script>
  </head>
  <body>
    <?php echo dcPage::breadcrumb(
		array(
			html::escapeHTML($core->blog->name) => '',
			__('Related pages') => ''
		)); ?>
    <?php if (!empty($message)):?>
    <p class="message"><?php echo $message;?></p>
    <?php endif;?>

    <div class="multi-part" id="related_settings" title="<?php echo __('Settings');?>">
      <form action="<?php echo $p_url;?>" method="post" enctype="multipart/form-data">
	<div class="fieldset">
	  <h3><?php echo __('Plugin activation'); ?></h3>
	  <p>
	    <?php echo form::checkbox('related_active', 1, $related_active);?>
	    <label class="classic" for="related_active"><?php echo __('Enable Related plugin');?></label>
	  </p>
	</div>

	<?php if ($related_active):?>
        <div class="fieldset">
          <h3><?php echo  __('General options');?></h3>
          <p>
	    <label class=" classic"><?php echo __('Repository path :').' ';?>
              <?php echo form::field('repository', 60, 255, $related_files_path);?>
            </label>
	  </p>
	</div>
        <div class="fieldset">
          <h3><?php echo __('Advanced options');?></h3>
          <p>
	    <label class=" classic"><?php echo  __('URL prefix :').' ';?>
	      <?php echo form::field('url_prefix', 60, 255, $related_url_prefix);?>
            </label>
	  </p>
	</div>
	<?php endif;?>
	<?php echo form::hidden('p','related');?>
	<?php echo $core->formNonce();?>
	<input type="submit" name="saveconfig" value="<?php echo __('Save configuration');?>"/>
      </form>
    </div>
    <?php if ($related_active):?>
    <div class="multi-part" id="pages_compose" title="<?php echo __('Manage pages');?>">
      <p class="top-add">
	<a class="button add" href="plugin.php?p=related&amp;do=edit&amp;st=post"><?php echo __('New post as page');?></a>
	&nbsp;-&nbsp;
        <a class="button add" href="plugin.php?p=related&amp;do=edit&amp;st=file"><?php echo __('New included page');?></a>
      </p>
      <?php
	 $page_list->display($page, $nb_per_page,
      '<form action="'.$core->adminurl->get('admin.plugin').'?p=related" method="post" id="form-pages">'.
        '%s'.
        '<div class="two-cols">'.
          '<p class="col checkboxes-helpers"></p>'.
          '<p class="col right">'.__('Selected entries action:').
            form::combo('action',$combo_action).
            '<input type="submit" value="'.__('ok').'" /></p>'.
          form::hidden(array('post_type'),'related').
	  form::hidden('p','related').
          $core->formNonce().
          '</div>'.
	'<p class="clear form-note hidden-if-js">'.
	  __('To rearrange pages order, change number at the begining of the line, then click on “Save pages order” button.').'</p>'.
	'<p class="clear form-note hidden-if-no-js">'.
	  __('To rearrange pages order, move items by drag and drop, then click on “Save pages order” button.').'</p>'.
	'<p><input type="submit" value="'.__('Save pages order').'" name="reorder" class="clear" /></p>'.
        '</form>'
      );
      ?>
    </div>
    <?php endif;?>
    <?php dcPage::helpBlock('related_pages');?>
  </body>
</html>
